/*
Copyright (C) 2003 by Kristis Makris. See the file AUTHORS for contact
information of all contributors.

This file is part of a framework that allows dynamic replacement of
core kernel components.

You may not use this work in any format (source/binary/documentation,
electronic/hardcopy.) for any purpose whatsoever, without the
permission of Kristis Makris. At some point in the future, this
program will be free software, licensed under the GPL License.
*/



#ifndef BENCHMARK_LIB_CORE_H
#define BENCHMARK_LIB_CORE_H

#define DEVEL_DEBUG_LEVEL DEVEL_DEBUG_NORMAL

#include <sys/time.h>
#define spin_unlock(lock)
#define spin_lock(lock)
#define spin_lock_init(lock)

typedef struct timeval benchmark_times_t;

#define BENCHMARK_LIB_NAME "benchmark_lib"
#define BENCHMARK_LIB_VERSION_STR "unknown"

#define benchmark_times_seconds tv_sec
#define benchmark_times_microseconds tv_usec

/* Guards access to the benchmark observations buffer */
#include <stdio.h>
#include <stdlib.h>
typedef int spinlock_t;
typedef spinlock_t benchmark_lock_t;

extern unsigned long benchmark_observations_number;

void benchmark_lib_flag_error(void);
int benchmark_lib_enabled(void);
void benchmark_lib_enable(void);
void benchmark_lib_disable(void);
int benchmark_lib_module_init(void);
void benchmark_lib_init(unsigned long observations_number);
void benchmark_lib_init_internal(unsigned long observations_number);
void benchmark_lock_init(void);
void inline benchmark_lib_lock(void);
void inline benchmark_lib_unlock(void);
void benchmark_lib_module_exit(void);
void benchmark_lib_exit(void);
void benchmark_lib_exit_internal(void);
void benchmark_lib_reset(void);
void benchmark_lib_store_times(benchmark_times_t *time_before, benchmark_times_t *time_after);
char *benchmark_lib_tostring(void);
void benchmark_lib_times_diff(benchmark_times_t *big,
			      benchmark_times_t *small,
			      benchmark_times_t *diff);

int benchmark_lib_proc_init(char * read_entry);
void benchmark_lib_proc_exit(void);
void benchmark_lib_pstats_init();
void benchmark_lib_ps_report();
void benchmark_lib_tms_report();


#endif /* BENCHMARK_LIB_CORE_H */
