/*
Copyright (C) 2003 by Kristis Makris. See the file AUTHORS for contact
information of all contributors.

This file is part of a framework that allows dynamic replacement of
core kernel components.

You may not use this work in any format (source/binary/documentation,
electronic/hardcopy.) for any purpose whatsoever, without the
permission of Kristis Makris. At some point in the future, this
program will be free software, licensed under the GPL License.
*/



#include "devel.h"
#include "benchmark_lib.h"
#include <unistd.h>
#ifdef DEBUG_USERSPACE
#include <mpatrol.h>
#endif /* DEBUG_USERSPACE */

int main()
{
  char *tostring;
  benchmark_times_t bt1;
  benchmark_times_t bt2;

  /* Initialize the library */
  benchmark_lib_init(10);
  benchmark_lib_enable();

  /* Store a couple of observations */
  gettimeofday(&bt1, NULL);
  sleep(1);
  gettimeofday(&bt2, NULL);
  benchmark_lib_store_times(&bt1, &bt2);

  benchmark_lib_reset();
  gettimeofday(&bt1, NULL);
  sleep(1);
  gettimeofday(&bt2, NULL);
  benchmark_lib_store_times(&bt1, &bt2);

  tostring = benchmark_lib_tostring();
  printf("%s", tostring);
  devel_free(tostring);

  /* Uninitialize the library */
  benchmark_lib_exit();

  return 0;
}
