#!/bin/sh

HOSTNAME=`uname -n | sed -e 's/\..*//'`

function prepare()
{
    POSTGRESQL_VERSION=$1
    COMPILER_TYPE=$2
    POSTGRESQL_PREFIX="/home/mkgnu/storage/sandbox/postgresql-${POSTGRESQL_VERSION}.${COMPILER_TYPE}"
    POSTGRESQL_DATA="${POSTGRESQL_PREFIX}/data"

    ./stop.sh
    cd build/postgresql-${POSTGRESQL_VERSION}.${COMPILER_TYPE}

    # If we must apply a patch for this compilation configuration,
    # apply it
    if [ -e ../../artifacts/postgresql-${POSTGRESQL_VERSION}.${COMPILER_TYPE}.patch ]; then
	patch -p2 < ../../artifacts/postgresql-${POSTGRESQL_VERSION}.${COMPILER_TYPE}.patch
    fi

    ./configure --prefix=${POSTGRESQL_PREFIX}
    make
    make install
    rm -rf ${POSTGRESQL_DATA};
    mkdir ${POSTGRESQL_DATA}
    ${POSTGRESQL_PREFIX}/bin/initdb -D ${POSTGRESQL_DATA}
    ${POSTGRESQL_PREFIX}/bin/postmaster -D ${POSTGRESQL_DATA} >logfile 2>&1 &
    POSTMASTER_PID=$!
    echo the postmaster was started with pid $POSTMASTER_PID
    sleep 2
    ${POSTGRESQL_PREFIX}/bin/createdb test
    echo stopping the postmaster with pid $POSTMASTER_PID
    kill -9 $POSTMASTER_PID

    cd ../..
}

prepare 7.4.11 hcucc_gcc41
prepare 7.4.12 hcucc_gcc41
prepare 7.4.13 hcucc_gcc41
prepare 7.4.14 hcucc_gcc41
prepare 7.4.15 hcucc_gcc41
prepare 7.4.16 cc_gcc41
prepare 7.4.16 hcucil_gcc41
prepare 7.4.16 hcumulti_gcc41
prepare 7.4.16 hcublock_gcc41
prepare 7.4.16 hcustack_gcc41
prepare 7.4.16 hcucc_gcc41
prepare 7.4.17 cc_gcc41
prepare 7.4.17 hcucil_gcc41
prepare 7.4.17 hcucc_gcc41
prepare 7.4.18 hcucc_gcc41
prepare 7.4.19 hcucc_gcc41

