#!/bin/sh


function prepare()
{
    POSTGRES_VERSION_OLD=$1
    POSTGRES_VERSION_NEW=$2
    POSTGRES_BASE_VERSION=$3
    POSTGRES_COMPILER_TYPE=$4


    POSTGRES_VERSION_NUMBER_OLD=`echo -n "$POSTGRES_VERSION_OLD" | sed -e 's/\.//g'`
    POSTGRES_VERSION_NUMBER_NEW=`echo $POSTGRES_VERSION_NEW | sed -e 's/\.//g'`
    POSTGRES_BASE_VERSION_NUMBER=`echo $POSTGRES_BASE_VERSION | sed -e 's/\.//g'`

    cd build

    # Copy the mappings file in the build directory, so that the
    # dynamic patch will also be generated in the build directory
    cp ../artifacts/${POSTGRES_VERSION_OLD}_to_${POSTGRES_VERSION_NEW}_mappings.c .
    POSTGRES_MAPPINGS=${POSTGRES_VERSION_OLD}_to_${POSTGRES_VERSION_NEW}_mappings.c
    POSTGRES_DIFF_RESULT=${POSTGRES_VERSION_OLD}_to_${POSTGRES_VERSION_NEW}_diff_result.txt
    POSTGRES_PREFIX="/home/mkgnu/storage/sandbox/postgresql-${POSTGRES_VERSION}.${COMPILER_TYPE}"

    hcu_build_patch.sh postgresql-${POSTGRES_VERSION_OLD}.${POSTGRES_COMPILER_TYPE}/src/backend/postgres_comb.c ${POSTGRES_VERSION_NUMBER_OLD} postgresql-${POSTGRES_VERSION_NEW}.${POSTGRES_COMPILER_TYPE}/src/backend/postgres_comb.c ${POSTGRES_VERSION_NUMBER_NEW} ${POSTGRES_MAPPINGS} ${POSTGRES_BASE_VERSION_NUMBER} > ${POSTGRES_DIFF_RESULT} 2>&1
    mv postgresql-${POSTGRES_VERSION_OLD}.${POSTGRES_COMPILER_TYPE}/src/backend/postgres_comb.c_v${POSTGRES_VERSION_NUMBER_OLD}_to_v${POSTGRES_VERSION_NUMBER_NEW}.hcupatch.c postgres_comb.c_v${POSTGRES_VERSION_NUMBER_OLD}_to_v${POSTGRES_VERSION_NUMBER_NEW}.hcupatch.c

    # Apply stack reconstruction to the patch
    PATCH_FILE=postgres_comb.c_v${POSTGRES_VERSION_NUMBER_OLD}_to_v${POSTGRES_VERSION_NUMBER_NEW}.hcupatch.c
    UPDATE_OBJECT_FILE=`echo -n $PATCH_FILE|sed -e 's/.c$/.o/'`
    UPDATE_SHARED_OBJECT_FILE=postgres_v${POSTGRES_VERSION_NUMBER_OLD}_to_v${POSTGRES_VERSION_NUMBER_NEW}.so
    hcucc.pl -g -c postgres_comb.c_v${POSTGRES_VERSION_NUMBER_OLD}_to_v${POSTGRES_VERSION_NUMBER_NEW}.hcupatch.c --update-version=${POSTGRES_VERSION_NUMBER_NEW} -o $UPDATE_OBJECT_FILE

    #
    # Now create a shared object from the newer version
    #
    hcucc.pl -g -shared -Wl,-soname=$UPDATE_SHARED_OBJECT_FILE.${POSTGRES_VERSION_NUMBER_NEW} -o lib$UPDATE_SHARED_OBJECT_FILE.${POSTGRES_VERSION_NUMBER_NEW} $UPDATE_OBJECT_FILE

    cd ..
}


prepare 7.4.16 7.4.17 7.4.16 hcucc_gcc41
