#!/usr/bin/perl -w

use strict;
use FileHandle;
use IPC::Open2;


main ( @ARGV );



sub main {
    my ( @arguments ) = ( @_ );

    if (scalar @arguments != 4) {
        print "usage: $0 <client_number> <db_name> <postgresql_prefix> <updated_version>\n";
        exit -1;
    }

    my ( $client_number, $db_name, $postgresql_prefix, $updated_version ) = ( @arguments );
    

    # Open a connection to the database using bidirectional communication
    print "client $client_number: opening connection...\n";
    my $client_output_file = "client_output_" . $client_number;
    my $pid = open( OUTFILE, "|$postgresql_prefix/bin/psql -o $client_output_file $db_name" );
    my $should_continue = 1;
    my $response;
    my $version;
    my $counter = 0;
    while ( $should_continue ) {
#         if ( $counter == 4) {
        # Used to test if will detect the version update and exit immediately.
#             print OUTFILE "select 'PostgreSQL 7.4.17 on i686-pc-linux-gnu, compiled by GCC gcc (GCC) 3.3.5 (Debian 1:3.3.5-13)' as version;\n";
#         } else {
            print OUTFILE "select version();\n";
#        };
        $response = "";
        $response = `cat $client_output_file`;
#        print "Response is: '$response'\n";
        $version = $response;
        $version =~ s/.*PostgreSQL\s*(\d+\.\d+\.\d+)\s*.*/$1/gs;
        print "client $client_number: PostgreSQL version is: '$version'\n";
        # Continuously issue queries until we have been updated 
        if ( $version eq $updated_version) {
            $should_continue = 0;
        } else {
            # Wait for a while
            sleep 1;
        }
        $counter++;
    }
    close( OUTFILE );
    print "client $client_number: Exiting...\n";
}
