#!/bin/sh


function stress
{
    POSTGRESQL_VERSION=$1
    COMPILER_TYPE=$2
    POSTGRESQL_PREFIX="/home/mkgnu/storage/sandbox/postgresql-${POSTGRESQL_VERSION}.${COMPILER_TYPE}"
    POSTGRESQL_DATA="${POSTGRESQL_PREFIX}/data"

    ./stop.sh
    cd build/postgresql-${POSTGRESQL_VERSION}.${COMPILER_TYPE}

    # Build the testsuite
    (cd src/test/regress; make)

    # Run the serial tests
    ${POSTGRESQL_PREFIX}/bin/postmaster -D ${POSTGRESQL_DATA} >logfile 2>&1 &
    POSTMASTER_PID=$!
    # Wait for the postmaster to start
    sleep 5
    echo the postmaster was started with pid $POSTMASTER_PID
    (cd src/test/regress; make installcheck)

    echo stopping the postmaster with pid $POSTMASTER_PID
    kill -9 $POSTMASTER_PID

    # Run the parallel tests
    (cd src/test/regress; make check)

    cd ../..

}


stress 7.4.16 cc_gcc33
stress 7.4.16 hcucc_gcc33
stress 7.4.17 cc_gcc33
stress 7.4.17 hcucc_gcc33
