#!/bin/sh


PGBENCH=/home/mkgnu/home/devel/postgresql-8.3.3/contrib/pgbench/pgbench
DB_NAME=hcucc_test
PUT_IN_MEMORY=0
COME_FROM_MEMORY=0
NUMBER_OF_TRANSACTIONS_RAMP_UP=40000
NUMBER_OF_TRANSACTIONS=100000

if [ $# -ne 3 ]; then
    echo "Usage: $0 <server_hostname> <server_version> <server_compiler>"
    exit -1
fi

HOSTNAME=$1
SERVER_VERSION=$2
SERVER_COMPILER=$3

# Store the pgbench output in a memory filesystem
if [ $PUT_IN_MEMORY = 1 ]; then
    TEMP=/dev/shm/pgbench_temp
else
    TEMP=/tmp/pgbench_temp
fi

if [ $COME_FROM_MEMORY = 1 ]; then
    RESULT=results/$HOSTNAME.memory.$SERVER_VERSION.$SERVER_COMPILER.$NUMBER_OF_TRANSACTIONS.result
    RAMP_UP=results/$HOSTNAME.memory.$SERVER_VERSION.$SERVER_COMPILER.$NUMBER_OF_TRANSACTIONS_RAMP_UP.rampup
else
    RESULT=results/$HOSTNAME.harddisk.$SERVER_VERSION.$SERVER_COMPILER.$NUMBER_OF_TRANSACTIONS.result
    RAMP_UP=results/$HOSTNAME.harddisk.$SERVER_VERSION.$SERVER_COMPILER.$NUMBER_OF_TRANSACTIONS_RAMP_UP.rampup
fi

echo -n "Warming up the cache (ramp-up time)..."
time $PGBENCH -h $HOSTNAME -d $DB_NAME -t $NUMBER_OF_TRANSACTIONS_RAMP_UP > $TEMP 2>&1
echo done
tail -8 $TEMP > $RAMP_UP

echo -n "Running actual experiment..."
time $PGBENCH -h $HOSTNAME -d $DB_NAME -t $NUMBER_OF_TRANSACTIONS > $TEMP 2>&1
echo done
tail -8 $TEMP > $RESULT

