#!/bin/sh

HOSTNAME=`uname -n | sed -e 's/\..*//'`

function test_server()
{
    POSTGRESQL_VERSION_OLD=$1
    POSTGRESQL_VERSION_NEW=$2
    COMPILER_TYPE=$3
    MUST_UPDATE=$4

    CUR_DIR=`pwd`
    POSTGRESQL_PREFIX="/home/mkgnu/storage/sandbox/postgresql-${POSTGRESQL_VERSION_OLD}.${COMPILER_TYPE}"
    POSTGRESQL_DATA="${CUR_DIR}/build/dataarea/postgresql-${POSTGRESQL_VERSION_OLD}.${COMPILER_TYPE}/data"

    POSTGRESQL_VERSION_NUMBER_OLD=`echo -n "$POSTGRESQL_VERSION_OLD" | sed -e 's/\.//g'`
    POSTGRESQL_VERSION_NUMBER_NEW=`echo -n "$POSTGRESQL_VERSION_NEW" | sed -e 's/\.//g'`




    echo ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    echo Will start a server for PostgreSQL version $POSTGRESQL_VERSION_OLD with compiler $COMPILER_TYPE

    # Start the postmaster
    ${POSTGRESQL_PREFIX}/bin/postmaster -D ${POSTGRESQL_DATA} >logfile 2>&1 &
    POSTMASTER_PID=$!
    # Wait for the postmaster to start
    sleep 5
    echo the postmaster was started with pid $POSTMASTER_PID

    if [ $MUST_UPDATE = 1 ]; then
	# Postgres must be updated
	echo "PostgreSQL must be updated. Coordinating update"

        # Apply an update
	UPDATE_SHARED_OBJECT_FILE=postgres_v${POSTGRESQL_VERSION_NUMBER_OLD}_to_v${POSTGRESQL_VERSION_NUMBER_NEW}.so
        sleep 2
	hcuapply --file=$CUR_DIR/build/lib$UPDATE_SHARED_OBJECT_FILE.${POSTGRESQL_VERSION_NUMBER_NEW} --update-version=${POSTGRESQL_VERSION_NUMBER_NEW} 2>&1
    fi

    echo Press Enter when you want to stop the server
    read junk


    echo stopping the postmaster with pid $POSTMASTER_PID
    kill -TERM $POSTMASTER_PID
    sleep 2

    cd ../../
}


test_server 7.4.16 7.4.17 cc_gcc41 0
test_server 7.4.16 7.4.17 hcucil_gcc41 0
test_server 7.4.16 7.4.17 hcumulti_gcc41 0
test_server 7.4.16 7.4.17 hcublock_gcc41 0
test_server 7.4.16 7.4.17 hcustack_gcc41 0
test_server 7.4.16 7.4.17 hcucc_gcc41 0
test_server 7.4.16 7.4.17 hcucc_gcc41 1
test_server 7.4.17 7.4.17 cc_gcc41 0
test_server 7.4.17 7.4.17 hcucc_gcc41 0
