#include "hcu_mappings.h"


hcu_mapping_update_description_t mapping_updates_v122[] = { { "main", "main" } };
hcu_mapping_function_update_description_t mapping_function_updates_v122[] = {
  { "emit_greeting", "emit_greeting", 0 },
  { "vsf_ftpdataio_get_pasv_fd", "vsf_ftpdataio_get_pasv_fd", 0 },
  { "vsf_sysutil_sockaddr_alloc", "vsf_sysutil_sockaddr_alloc", 0 },
  { "vsf_sysutil_statbuf_get_sortkey_mtime", "vsf_sysutil_statbuf_get_sortkey_mtime", 0 },
  { "main", "main", 1 },
  { "vsf_one_process_start", "vsf_one_process_start", 0 },
  { "handle_cdup", "handle_cdup", 0 },
  { "vsf_standalone_main", "vsf_standalone_main", 0 },
  { "vsf_sysutil_accept_timeout", "vsf_sysutil_accept_timeout", 0 },
  { "do_sanity_checks", "do_sanity_checks", 0 }
};


hcu_mapping_algorithmic_equivalence_t mapping_equivalence_v122_main[] = {
  { "main",
    "main",
    1,
    { { 12, 14 }
    }
  }
};

hcu_mapping_algorithmic_equivalence_t mapping_equivalence_v122_vsf_standalone_main[] = {
  { "vsf_standalone_main",
    "vsf_standalone_main",
    1,
    { { 40, 41 }
    }
  }
};

hcu_mapping_algorithmic_equivalence_t mapping_equivalence_v122_vsf_one_process_start[] = {
  { "vsf_one_process_start",
    "vsf_one_process_start",
    1,
    { { 7, 9 }
    }
  }
};

void hcu_set_update_mode_off();
void hcu_set_update_mode_on();


struct hcu_stack_frame_fields_s {
   long must_come_back_to ;
};


struct parseconf_bool_setting {
   char const   *p_setting_name ;
   int *p_variable ;
};

struct vsf_client_launch {
   unsigned int num_children ;
   unsigned int num_this_ip ;
};

struct vsf_sysutil_statbuf;

typedef long long filesize_t;
typedef unsigned short uint16_t;
typedef uint16_t in_port_t;
typedef unsigned short sa_family_t;
typedef unsigned int uint32_t;
typedef unsigned char uint8_t;


typedef unsigned short sa_family_t;
struct sockaddr {
   sa_family_t sa_family ;
   char sa_data[14] ;
};

typedef uint32_t in_addr_t;
struct in_addr {
   in_addr_t s_addr ;
};

struct sockaddr_in {
   sa_family_t sin_family ;
   in_port_t sin_port ;
   struct in_addr sin_addr ;
   unsigned char sin_zero[((sizeof(struct sockaddr ) - sizeof(unsigned short )) - sizeof(in_port_t )) - sizeof(struct in_addr )] ;
};

union __anonunion_in6_u_65 {
   uint8_t u6_addr8[16] ;
   uint16_t u6_addr16[8] ;
   uint32_t u6_addr32[4] ;
};
struct in6_addr {
   union __anonunion_in6_u_65 in6_u ;
};

struct sockaddr_in6 {
   sa_family_t sin6_family ;
   in_port_t sin6_port ;
   uint32_t sin6_flowinfo ;
   struct in6_addr sin6_addr ;
   uint32_t sin6_scope_id ;
};

union __anonunion_u_79 {
   struct sockaddr u_sockaddr ;
   struct sockaddr_in u_sockaddr_in ;
   struct sockaddr_in6 u_sockaddr_in6 ;
};
struct vsf_sysutil_sockaddr {
   union __anonunion_u_79 u ;
};



struct mystr {
   char *PRIVATE_HANDS_OFF_p_buf ;
   unsigned int PRIVATE_HANDS_OFF_len ;
   unsigned int PRIVATE_HANDS_OFF_alloc_bytes ;
};

struct mystr_list_node;
struct mystr_list {
   unsigned int PRIVATE_HANDS_OFF_alloc_len ;
   unsigned int PRIVATE_HANDS_OFF_list_len ;
   struct mystr_list_node *PRIVATE_HANDS_OFF_p_nodes ;
};

struct mystr_list_node {
   struct mystr str ;
   struct mystr sort_key_str ;
};

struct vsf_session {
   struct vsf_sysutil_sockaddr *p_local_addr ;
   struct vsf_sysutil_sockaddr *p_remote_addr ;
   int pasv_listen_fd ;
   struct vsf_sysutil_sockaddr *p_port_sockaddr ;
   int data_fd ;
   int data_progress ;
   unsigned int bw_rate_max ;
   long bw_send_start_sec ;
   long bw_send_start_usec ;
   int is_anonymous ;
   struct mystr user_str ;
   struct mystr anon_pass_str ;
   filesize_t restart_pos ;
   int is_ascii ;
   struct mystr rnfr_filename_str ;
   int abor_received ;
   int epsv_all ;
   struct mystr_list *p_visited_dir_list ;
   int anon_ftp_uid ;
   int guest_user_uid ;
   int anon_upload_chown_uid ;
   struct mystr banned_email_str ;
   struct mystr email_passwords_str ;
   struct mystr userlist_str ;
   struct mystr banner_str ;
   int tcp_wrapper_ok ;
   int xferlog_fd ;
   int vsftpd_log_fd ;
   struct mystr remote_ip_str ;
   unsigned long log_type ;
   long log_start_sec ;
   long log_start_usec ;
   struct mystr log_str ;
   filesize_t transfer_size ;
   struct mystr ftp_cmd_str ;
   struct mystr ftp_arg_str ;
   int privsock_inited ;
   int parent_fd ;
   int child_fd ;
   unsigned int num_clients ;
   unsigned int num_this_ip ;
};


struct hcu_stack_local_main_v121_s {
   struct vsf_session the_session ;
   int config_specified ;
   char const   *p_config_name ;
   struct vsf_sysutil_statbuf *p_statbuf___0 ;
   int retval ;
   int tmp ;
   int tmp___0 ;
   struct vsf_client_launch ret ;
   struct vsf_client_launch tmp___1 ;
   char const   *tmp___2 ;
   char const   *p_load_conf ;
   char *tmp___3 ;
   int retval___0 ;
   int tmp___4 ;
   int tmp___5 ;
   int retval___1 ;
   int tmp___6 ;
   int tmp___7 ;
   int retval___2 ;
   int tmp___8 ;
   int tmp___9 ;
   struct hcu_stack_frame_fields_s hcu_stack_frame_fields ;
};

struct hcu_function_formal_main_v121_s {
   int argc ;
   char const   **argv ;
};

struct hcu_stack_local_main_v122_s {
   struct vsf_session the_session ;
   int config_specified ;
   char const   *p_config_name ;
   int tmp ;
   struct vsf_sysutil_statbuf *p_statbuf___0 ;
   int retval ;
   int tmp___0 ;
   int tmp___1 ;
   struct vsf_client_launch ret ;
   struct vsf_client_launch tmp___2 ;
   char const   *tmp___3 ;
   char const   *p_load_conf ;
   char *tmp___4 ;
   int retval___0 ;
   int tmp___5 ;
   int tmp___6 ;
   int retval___1 ;
   int tmp___7 ;
   int tmp___8 ;
   int retval___2 ;
   int tmp___9 ;
   int tmp___10 ;
   struct hcu_stack_frame_fields_s hcu_stack_frame_fields ;
};

struct hcu_function_formal_main_v122_s {
   int argc ;
   char const   **argv ;
};




struct hcu_stack_local_vsf_standalone_main_v121_s {
   int listen_sock ;
   int retval ;
   int forkret ;
   int tmp ;
   struct vsf_sysutil_sockaddr *p_sockaddr___0 ;
   int tmp___0 ;
   int tmp___1 ;
   struct vsf_sysutil_sockaddr *p_sockaddr___1 ;
   struct mystr addr_str ;
   unsigned char const   *p_raw_addr ;
   int tmp___2 ;
   struct vsf_client_launch child_info ;
   void *p_raw_addr___0 ;
   int new_child ;
   int new_client_sock ;
   int tmp___3 ;
   struct hcu_stack_frame_fields_s hcu_stack_frame_fields ;
};

struct hcu_function_formal_vsf_standalone_main_v121_s {

};

struct hcu_stack_local_vsf_standalone_main_v122_s {
   struct vsf_sysutil_sockaddr *p_accept_addr ;
   int listen_sock ;
   int retval ;
   int forkret ;
   int tmp ;
   struct vsf_sysutil_sockaddr *p_sockaddr___0 ;
   int tmp___0 ;
   int tmp___1 ;
   struct vsf_sysutil_sockaddr *p_sockaddr___1 ;
   struct mystr addr_str ;
   unsigned char const   *p_raw_addr ;
   int tmp___2 ;
   struct vsf_client_launch child_info ;
   void *p_raw_addr___0 ;
   int new_child ;
   int new_client_sock ;
   int tmp___3 ;
   struct hcu_stack_frame_fields_s hcu_stack_frame_fields ;
};

struct hcu_function_formal_vsf_standalone_main_v122_s {

};


extern int tunable_run_as_launching_user  ;
extern struct parseconf_bool_setting parseconf_bool_array[50] ;
static struct parseconf_bool_setting parseconf_bool_array_v122[51]  __attribute__((__HCU_ATTRIBUTE_VERSION_HAS_BEEN_SET__))  ;



void HCU_datatype_transformation__struct__vsf_session___to_struct__vsf_session__(struct vsf_session *old ,
                                                                                 struct vsf_session *new )  __attribute__((__HCU_ATTRIBUTE_VERSION_HAS_BEEN_SET__,
__HCU_ATTRIBUTE_NON_UPDATEABLE__)) ;
void HCU_datatype_transformation__struct__vsf_client_launch___to_struct__vsf_client_launch__(struct vsf_client_launch *old ,
                                                                                             struct vsf_client_launch *new )  __attribute__((__HCU_ATTRIBUTE_VERSION_HAS_BEEN_SET__,
__HCU_ATTRIBUTE_NON_UPDATEABLE__)) ;


void HCU_stack_transformer__vsf_standalone_main(void *transform_stack_to ,
                                                void *transform_stack_from ,
                                                void *transform_params_to )  __attribute__((__HCU_ATTRIBUTE_NON_UPDATEABLE__)) ;
void HCU_stack_transformer__vsf_standalone_main(void *transform_stack_to ,
                                                void *transform_stack_from ,
                                                void *transform_params_to ) 
{ struct hcu_stack_local_vsf_standalone_main_v122_s *stack_to ;
  struct hcu_stack_local_vsf_standalone_main_v121_s *stack_from ;
  struct hcu_function_formal_vsf_standalone_main_v122_s *params_to ;

  {
  stack_to = (struct hcu_stack_local_vsf_standalone_main_v122_s *)transform_stack_to;
  stack_from = (struct hcu_stack_local_vsf_standalone_main_v121_s *)transform_stack_from;
  params_to = (struct hcu_function_formal_vsf_standalone_main_v122_s *)transform_params_to;
  hcu_copy_stack_frame_fields(& stack_to->hcu_stack_frame_fields,
                              & stack_from->hcu_stack_frame_fields);
  HCU_datatype_transformation__struct__mystr___to_struct__mystr__(& stack_from->addr_str,
                                                                  & stack_to->addr_str);
  HCU_datatype_transformation__struct__vsf_client_launch___to_struct__vsf_client_launch__(& stack_from->child_info,
                                                                                          & stack_to->child_info);
  stack_to->listen_sock = stack_from->listen_sock;
  stack_to->retval = stack_from->retval;
  stack_to->forkret = stack_from->forkret;
  stack_to->tmp = stack_from->tmp;
  stack_to->p_sockaddr___0 = stack_from->p_sockaddr___0;
  stack_to->tmp___0 = stack_from->tmp___0;
  stack_to->tmp___1 = stack_from->tmp___1;
  stack_to->p_sockaddr___1 = stack_from->p_sockaddr___1;
  stack_to->p_raw_addr = stack_from->p_raw_addr;
  stack_to->tmp___2 = stack_from->tmp___2;
  stack_to->p_raw_addr___0 = stack_from->p_raw_addr___0;
  stack_to->new_child = stack_from->new_child;
  stack_to->new_client_sock = stack_from->new_client_sock;
  stack_to->tmp___3 = stack_from->tmp___3;

  // Must initialize this
  stack_to->p_accept_addr = 0;
  hcu_set_update_mode_off();
  vsf_sysutil_sockaddr_alloc(&stack_to->p_accept_addr);
  hcu_set_update_mode_on();
}
}



void HCU_stack_transformer__hcu_wrapped_main(void *transform_stack_to ,
                                             void *transform_stack_from ,
                                             void *transform_params_to )  __attribute__((__HCU_ATTRIBUTE_NON_UPDATEABLE__)) ;
void HCU_stack_transformer__hcu_wrapped_main(void *transform_stack_to ,
                                             void *transform_stack_from ,
                                             void *transform_params_to ) 
{ struct hcu_stack_local_main_v122_s *stack_to ;
  struct hcu_stack_local_main_v121_s *stack_from ;
  struct hcu_function_formal_main_v122_s *params_to ;

  {
  stack_to = (struct hcu_stack_local_main_v122_s *)transform_stack_to;
  stack_from = (struct hcu_stack_local_main_v121_s *)transform_stack_from;
  params_to = (struct hcu_function_formal_main_v122_s *)transform_params_to;
  hcu_copy_stack_frame_fields(& stack_to->hcu_stack_frame_fields,
                              & stack_from->hcu_stack_frame_fields);
  HCU_datatype_transformation__struct__vsf_session___to_struct__vsf_session__(& stack_from->the_session,
                                                                              & stack_to->the_session);
  HCU_datatype_transformation__struct__vsf_client_launch___to_struct__vsf_client_launch__(& stack_from->ret,
                                                                                          & stack_to->ret);
  stack_to->config_specified = stack_from->config_specified;
  stack_to->p_config_name = stack_from->p_config_name;
  stack_to->tmp = stack_from->tmp;
  stack_to->p_statbuf___0 = stack_from->p_statbuf___0;
  stack_to->retval = stack_from->retval;
  stack_to->p_load_conf = stack_from->p_load_conf;
  stack_to->retval___0 = stack_from->retval___0;
  stack_to->retval___1 = stack_from->retval___1;
  stack_to->retval___2 = stack_from->retval___2;

  // Must customize the preservation of the temporary variables
  stack_to->tmp___0 = stack_from->tmp;
  stack_to->tmp___2 = stack_from->tmp___1;
  stack_to->tmp___3 = stack_from->tmp___2;
  stack_to->tmp___4 = stack_from->tmp___3;
  stack_to->tmp___5 = stack_from->tmp___4;
  stack_to->tmp___6 = stack_from->tmp___5;
  stack_to->tmp___7 = stack_from->tmp___6;
  stack_to->tmp___8 = stack_from->tmp___7;
  stack_to->tmp___9 = stack_from->tmp___8;
  stack_to->tmp___10 = stack_from->tmp___9;
}
}



void HCU_datatype_transformation__struct__parseconf_bool_setting__arraysize50_to_struct__parseconf_bool_setting__arraysize51(struct parseconf_bool_setting (*old)[50] ,
                                                                                                                             struct parseconf_bool_setting (*new)[51] )  __attribute__((__HCU_ATTRIBUTE_VERSION_HAS_BEEN_SET__,
__HCU_ATTRIBUTE_NON_UPDATEABLE__)) ;
void HCU_datatype_transformation__struct__parseconf_bool_setting__arraysize50_to_struct__parseconf_bool_setting__arraysize51(struct parseconf_bool_setting (*old)[50] ,
                                                                                                                             struct parseconf_bool_setting (*new)[51] ) 
{ long array_counter ;

  {
  array_counter = 0;
  while (1) {
    HCU_datatype_transformation__struct__parseconf_bool_setting__arraysize50_to_struct__parseconf_bool_setting__arraysize51__element(& (*old)[array_counter],
                                                                                                                                     & (*new)[array_counter]);
    if (array_counter >= 50 - 1) {
      break;
    }
    array_counter ++;
  }

  // Must extend the array
  ((*new)[49]).p_setting_name = malloc(strlen("run_as_launching_user") + 1);
  memcpy(&((*new)[49]).p_setting_name, "run_as_launching_user" "\0", strlen("run_as_launching_user") + 1);
  ((*new)[49]).p_variable = &tunable_run_as_launching_user;

  ((*new)[50]).p_setting_name = 0;
  ((*new)[50]).p_variable = 0;
}
}

int HCU_datatype_transformations_function()  __attribute__((__HCU_ATTRIBUTE_NON_UPDATEABLE__)) ;
int HCU_datatype_transformations_function() 
{ 

  {
  HCU_datatype_transformation__struct__parseconf_bool_setting__arraysize50_to_struct__parseconf_bool_setting__arraysize51(& parseconf_bool_array,
                                                                                                                          & parseconf_bool_array_v122);
  printf("HCU_datatype_transformations_function_v122 executed\n");

  // Must initialize this
  tunable_run_as_launching_user = 0;
  return (0);
}
}
