#include "hcu_mappings.h"


hcu_mapping_update_description_t mapping_updates_v204[] = { { "main", "main" } };
hcu_mapping_function_update_description_t mapping_function_updates_v204[] = {
  { "emit_greeting", "emit_greeting", 0 },
  { "handle_mdtm", "handle_mdtm", 0 },
  { "handle_retr", "handle_retr", 0 },
  { "handle_stat", "handle_stat", 0 },
  { "handle_upload_common", "handle_upload_common", 0 },
  { "handle_user_command", "handle_user_command", 0 },
  { "main", "main", 1 },
  { "vsf_filename_passes_filter", "vsf_filename_passes_filter", 0 },
  { "vsf_log_do_log_to_file", "vsf_log_do_log_to_file", 0 },
  { "vsf_standalone_main", "vsf_standalone_main", 0 },
  { "vsf_sysutil_chroot", "vsf_sysutil_chroot", 0 },
  { "vsf_sysutil_memcpy", "vsf_sysutil_memcpy", 0 },
  { "vsf_sysutil_strlen", "vsf_sysutil_strlen", 0 },
  { "vsf_sysutil_tzset", "vsf_sysutil_tzset", 0 }
};

hcu_mapping_algorithmic_equivalence_t mapping_equivalence_v204_main[] = {
  { "main",
    "main",
    1,
    { { 15, 20 }
    }
  }
};



hcu_mapping_algorithmic_equivalence_t mapping_equivalence_v204_vsf_standalone_main[] = {
  { "vsf_standalone_main",
    "vsf_standalone_main",
    1,
    { { 41, 44 }
    }
  }
};


void hcu_set_update_mode_off();
void hcu_set_update_mode_on();


struct hcu_stack_frame_fields_s {
   long must_come_back_to ;
};
typedef struct hcu_stack_frame_fields_s hcu_stack_frame_fields_t;

typedef long long filesize_t;

struct mystr {
   char *PRIVATE_HANDS_OFF_p_buf ;
   unsigned int PRIVATE_HANDS_OFF_len ;
   unsigned int PRIVATE_HANDS_OFF_alloc_bytes ;
};

struct mystr_list_node;
struct mystr_list {
   unsigned int PRIVATE_HANDS_OFF_alloc_len ;
   unsigned int PRIVATE_HANDS_OFF_list_len ;
   struct mystr_list_node *PRIVATE_HANDS_OFF_p_nodes ;
};

struct mystr_list_node {
   struct mystr str ;
   struct mystr sort_key_str ;
};


typedef unsigned short sa_family_t;

struct sockaddr {
   sa_family_t sa_family ;
   char sa_data[14] ;
};


typedef unsigned char uint8_t;
typedef unsigned short uint16_t;
typedef uint16_t in_port_t;
typedef unsigned int uint32_t;
typedef uint32_t in_addr_t;

struct in_addr {
   in_addr_t s_addr ;
};


struct sockaddr_in {
   sa_family_t sin_family ;
   in_port_t sin_port ;
   struct in_addr sin_addr ;
   unsigned char sin_zero[((sizeof(struct sockaddr ) - sizeof(unsigned short )) - sizeof(in_port_t )) - sizeof(struct in_addr )] ;
};


union __anonunion_in6_u_65 {
   uint8_t u6_addr8[16] ;
   uint16_t u6_addr16[8] ;
   uint32_t u6_addr32[4] ;
};

struct in6_addr {
   union __anonunion_in6_u_65 in6_u ;
};


struct sockaddr_in6 {
   sa_family_t sin6_family ;
   in_port_t sin6_port ;
   uint32_t sin6_flowinfo ;
   struct in6_addr sin6_addr ;
   uint32_t sin6_scope_id ;
};


union __anonunion_u_79 {
   struct sockaddr u_sockaddr ;
   struct sockaddr_in u_sockaddr_in ;
   struct sockaddr_in6 u_sockaddr_in6 ;
};
struct vsf_sysutil_sockaddr {
   union __anonunion_u_79 u ;
};




struct vsf_session {
   struct vsf_sysutil_sockaddr *p_local_addr ;
   struct vsf_sysutil_sockaddr *p_remote_addr ;
   char *p_control_line_buf ;
   int pasv_listen_fd ;
   struct vsf_sysutil_sockaddr *p_port_sockaddr ;
   int data_fd ;
   int data_progress ;
   unsigned int bw_rate_max ;
   long bw_send_start_sec ;
   long bw_send_start_usec ;
   int is_anonymous ;
   struct mystr user_str ;
   struct mystr anon_pass_str ;
   filesize_t restart_pos ;
   int is_ascii ;
   struct mystr rnfr_filename_str ;
   int abor_received ;
   int epsv_all ;
   struct mystr_list *p_visited_dir_list ;
   int anon_ftp_uid ;
   int guest_user_uid ;
   int anon_upload_chown_uid ;
   struct mystr banned_email_str ;
   struct mystr email_passwords_str ;
   struct mystr userlist_str ;
   struct mystr banner_str ;
   int tcp_wrapper_ok ;
   int xferlog_fd ;
   int vsftpd_log_fd ;
   struct mystr remote_ip_str ;
   unsigned long log_type ;
   long log_start_sec ;
   long log_start_usec ;
   struct mystr log_str ;
   filesize_t transfer_size ;
   struct mystr ftp_cmd_str ;
   struct mystr ftp_arg_str ;
   int parent_fd ;
   int child_fd ;
   unsigned int num_clients ;
   unsigned int num_this_ip ;
   struct mystr home_str ;
   int control_use_ssl ;
   int data_use_ssl ;
   void *p_ssl_ctx ;
   void *p_control_ssl ;
   void *p_data_ssl ;
   int ssl_slave_active ;
   int ssl_slave_fd ;
   int ssl_consumer_fd ;
};


struct vsf_sysutil_statbuf;

struct vsf_client_launch {
   unsigned int num_children ;
   unsigned int num_this_ip ;
};



struct hcu_stack_local_main_v203_s {
   struct vsf_session the_session ;
   int config_specified ;
   char const   *p_config_name ;
   int tmp ;
   struct vsf_sysutil_statbuf *p_statbuf___0 ;
   int retval ;
   int tmp___0 ;
   int tmp___1 ;
   struct vsf_client_launch ret___0 ;
   struct vsf_client_launch tmp___2 ;
   char const   *tmp___3 ;
   char const   *p_load_conf ;
   char *tmp___4 ;
   int retval___0 ;
   int tmp___5 ;
   int tmp___6 ;
   int retval___1 ;
   int tmp___7 ;
   int tmp___8 ;
   int retval___2 ;
   int tmp___9 ;
   int tmp___10 ;
   int tmp___11 ;
   struct hcu_stack_frame_fields_s hcu_stack_frame_fields ;
};

struct hcu_function_formal_main_v203_s {
   int argc ;
   char const   **argv ;
};

struct hcu_stack_local_main_v204_s {
   struct vsf_session the_session ;
   int config_specified ;
   char const   *p_config_name ;
   int tmp ;
   struct vsf_sysutil_statbuf *p_statbuf___0 ;
   int retval ;
   int tmp___0 ;
   int tmp___1 ;
   struct vsf_sysutil_sockaddr *p_addr ;
   char const   *p_numeric_addr ;
   char *tmp___2 ;
   struct vsf_client_launch ret___0 ;
   struct vsf_client_launch tmp___3 ;
   char const   *p_load_conf ;
   char *tmp___4 ;
   char const   *tmp___5 ;
   int retval___0 ;
   int tmp___6 ;
   int tmp___7 ;
   int retval___1 ;
   int tmp___8 ;
   int tmp___9 ;
   int retval___2 ;
   int tmp___10 ;
   int tmp___11 ;
   int tmp___12 ;
   struct hcu_stack_frame_fields_s hcu_stack_frame_fields ;
};

struct hcu_function_formal_main_v204_s {
   int argc ;
   char const   **argv ;
};

struct parseconf_bool_setting {
   char const   *p_setting_name ;
   int *p_variable ;
};



extern int tunable_mdtm_write;
extern int tunable_lock_upload_files;
extern int tunable_pasv_addr_resolve;

extern int tunable_tcp_wrappers ;
extern char const   *tunable_pasv_address ;


extern struct parseconf_bool_setting parseconf_bool_array[62] ;
extern struct parseconf_bool_setting parseconf_bool_array_v204[65]  __attribute__((__HCU_ATTRIBUTE_VERSION_HAS_BEEN_SET__))  ;


void HCU_datatype_transformation__struct__vsf_session___to_struct__vsf_session__(struct vsf_session *old ,
                                                                                 struct vsf_session *new )  __attribute__((__HCU_ATTRIBUTE_VERSION_HAS_BEEN_SET__,
__HCU_ATTRIBUTE_NON_UPDATEABLE__)) ;
void HCU_datatype_transformation__struct__vsf_client_launch___to_struct__vsf_client_launch__(struct vsf_client_launch *old ,
                                                                                             struct vsf_client_launch *new )  __attribute__((__HCU_ATTRIBUTE_VERSION_HAS_BEEN_SET__,
__HCU_ATTRIBUTE_NON_UPDATEABLE__)) ;




void HCU_stack_transformer__hcu_wrapped_main(void *transform_stack_to ,
                                             void *transform_stack_from ,
                                             void *transform_params_to )  __attribute__((__HCU_ATTRIBUTE_NON_UPDATEABLE__)) ;
void HCU_stack_transformer__hcu_wrapped_main(void *transform_stack_to ,
                                             void *transform_stack_from ,
                                             void *transform_params_to ) 
{ struct hcu_stack_local_main_v204_s *stack_to ;
  struct hcu_stack_local_main_v203_s *stack_from ;
  struct hcu_function_formal_main_v204_s *params_to ;

  stack_to = (struct hcu_stack_local_main_v204_s *)transform_stack_to;
  stack_from = (struct hcu_stack_local_main_v203_s *)transform_stack_from;
  params_to = (struct hcu_function_formal_main_v204_s *)transform_params_to;
  hcu_copy_stack_frame_fields(& stack_to->hcu_stack_frame_fields,
                              & stack_from->hcu_stack_frame_fields);
  HCU_datatype_transformation__struct__vsf_session___to_struct__vsf_session__(& stack_from->the_session,
                                                                              & stack_to->the_session);
  HCU_datatype_transformation__struct__vsf_client_launch___to_struct__vsf_client_launch__(& stack_from->ret___0,
                                                                                          & stack_to->ret___0);
  stack_to->config_specified = stack_from->config_specified;
  stack_to->p_config_name = stack_from->p_config_name;
  stack_to->tmp = stack_from->tmp;
  stack_to->p_statbuf___0 = stack_from->p_statbuf___0;
  stack_to->retval = stack_from->retval;
  stack_to->tmp___0 = stack_from->tmp___0;
  stack_to->tmp___1 = stack_from->tmp___1;
  stack_to->p_load_conf = stack_from->p_load_conf;
  stack_to->tmp___4 = stack_from->tmp___4;
  stack_to->retval___0 = stack_from->retval___0;
  stack_to->retval___1 = stack_from->retval___1;
  stack_to->retval___2 = stack_from->retval___2;

  // Preserve the temporaries that have been renamed
  stack_to->tmp___3 = stack_from->tmp___2;
  stack_to->tmp___5 = stack_from->tmp___3;
  stack_to->tmp___6 = stack_from->tmp___5;
  stack_to->tmp___7 = stack_from->tmp___6;
  stack_to->tmp___8 = stack_from->tmp___7;
  stack_to->tmp___9 = stack_from->tmp___8;
  stack_to->tmp___10 = stack_from->tmp___9;
  stack_to->tmp___11 = stack_from->tmp___10;
  stack_to->tmp___12 = stack_from->tmp___11;

  // Run some code that is part of the new version
  hcu_set_update_mode_off();

  if (tunable_pasv_address) {
    if (tunable_pasv_addr_resolve) {
      stack_to->p_addr = (struct vsf_sysutil_sockaddr *)0;
      vsf_sysutil_dns_resolve(& stack_to->p_addr, tunable_pasv_address);
      vsf_sysutil_free((void *)((char *)tunable_pasv_address));
      stack_to->p_numeric_addr = vsf_sysutil_inet_ntop((struct vsf_sysutil_sockaddr  const  *)stack_to->p_addr);
      tmp___2 = vsf_sysutil_strdup(stack_to->p_numeric_addr);
      tunable_pasv_address = (char const   *)tmp___2;
      vsf_sysutil_free((void *)stack_to->p_addr);
    }
  }

  hcu_set_update_mode_on();
}





void HCU_datatype_transformation__struct__parseconf_bool_setting__arraysize62_to_struct__parseconf_bool_setting__arraysize65(struct parseconf_bool_setting (*old)[62] ,
                                                                                                                             struct parseconf_bool_setting (*new)[65] )  __attribute__((__HCU_ATTRIBUTE_VERSION_HAS_BEEN_SET__,
__HCU_ATTRIBUTE_NON_UPDATEABLE__)) ;
void HCU_datatype_transformation__struct__parseconf_bool_setting__arraysize62_to_struct__parseconf_bool_setting__arraysize65(struct parseconf_bool_setting (*old)[62] ,
                                                                                                                             struct parseconf_bool_setting (*new)[65] ) 
{ long array_counter ;

  {
  array_counter = 0;
  while (1) {
    HCU_datatype_transformation__struct__parseconf_bool_setting__arraysize62_to_struct__parseconf_bool_setting__arraysize65__element(& (*old)[array_counter],
                                                                                                                                     & (*new)[array_counter]);
    if (array_counter >= 62 - 1) {
      break;
    }
    array_counter ++;
  }

  // Must extend the array
  ((*new)[61]).p_setting_name = malloc(strlen("mdtm_write") + 1);
  memcpy(&((*new)[61]).p_setting_name, "mdtm_write" "\0", strlen("mdtm_write") + 1);
  ((*new)[61]).p_variable = &tunable_mdtm_write;

  ((*new)[62]).p_setting_name = malloc(strlen("lock_upload_files") + 1);
  memcpy(&((*new)[62]).p_setting_name, "lock_upload_files" "\0", strlen("lock_upload_files") + 1);
  ((*new)[62]).p_variable = &tunable_lock_upload_files;

  ((*new)[63]).p_setting_name = malloc(strlen("pasv_addr_resolve") + 1);
  memcpy(&((*new)[63]).p_setting_name, "pasv_addr_resolve" "\0", strlen("pasv_addr_resolve") + 1);
  ((*new)[63]).p_variable = &tunable_pasv_addr_resolve;

  ((*new)[64]).p_setting_name = 0;
  ((*new)[64]).p_variable = 0;

}
}




int HCU_datatype_transformations_function()  __attribute__((__HCU_ATTRIBUTE_NON_UPDATEABLE__)) ;
int HCU_datatype_transformations_function() 
{ 

  {
  HCU_datatype_transformation__struct__parseconf_bool_setting__arraysize62_to_struct__parseconf_bool_setting__arraysize65(& parseconf_bool_array,
                                                                                                                          & parseconf_bool_array_v204);

  // Initialize these variables
  tunable_mdtm_write = 1;
  tunable_lock_upload_files = 1;
  tunable_pasv_addr_resolve = 0;

  printf("HCU_datatype_transformations_function_v204 executed\n");
  return (0);
}
}
