#!/bin/sh


function prepare_ftp_benchmark()
{
    cd build/dkftpbench-0.45

    # Apply a patch that fixes a compilation problem
    patch -p2 < ../../artifacts/dkftpbench-0.45.patch

    ./configure CC=gcc-4.1
    make
    make check

    cd ../..
}



function prepare()
{
    VSFTPD_VERSION=$1
    COMPILER_TYPE=$2

    echo Building vsFTPd $VSFTPD_VERSION with compiler $COMPILER_TYPE
    cd build/vsftpd-${VSFTPD_VERSION}.${COMPILER_TYPE}

    # If we must apply a patch for this compilation configuration,
    # apply it
    if [ -e ../../artifacts/vsftpd-${VSFTPD_VERSION}.${COMPILER_TYPE}.patch ]; then
	patch -p2 < ../../artifacts/vsftpd-${VSFTPD_VERSION}.${COMPILER_TYPE}.patch
    fi
    
    make

    cd ../..
}


prepare_ftp_benchmark
prepare 1.1.0 hcucc_gcc41
prepare 1.1.1 hcucc_gcc41
prepare 1.1.2 hcucc_gcc41
prepare 1.1.3 hcucc_gcc41
prepare 1.2.0 hcucc_gcc41
prepare 1.2.1 hcucc_gcc41
prepare 1.2.2 hcucc_gcc41
prepare 2.0.0 hcucc_gcc41
prepare 2.0.1 hcucc_gcc41
prepare 2.0.2 hcucc_gcc41
prepare 2.0.3 hcucc_gcc41
prepare 2.0.4 hcucc_gcc41
prepare 2.0.5 cc_gcc41
prepare 2.0.5 hcumulti_gcc41
prepare 2.0.5 hcublock_gcc41
prepare 2.0.5 hcustack_gcc41
prepare 2.0.5 hcucc_gcc41
prepare 2.0.6 cc_gcc41
prepare 2.0.6 hcucc_gcc41
